/**
  ******************************************************************************
  * ļ: bsp_General.h 
  *     : ӲʯǶʽŶ
  *     : V1.0
  * д: 2019-04-16
  *     : TIM-API
  ******************************************************************************
  * ˵
  * Ӳʯstm32YS-H7Multiʹá
  * 
  * Ա
  * ̳http://www.ing10bbs.com
  * ȨӲʯǶʽŶУá
  ******************************************************************************
  */
#ifndef __GENERAL_TIM_H__
#define __GENERAL_TIM_H__

/* ͷļ ----------------------------------------------------------------*/
#include "stm32h7xx_hal.h"

/* Ͷ ------------------------------------------------------------------*/

/* 궨 --------------------------------------------------------------------*/
//#define USE_TIM4
#define USE_TIM5


#ifdef USE_TIM4
/******************** ͨöʱTIM壬TIM4 *****************************/

#define GENERAL_TIMx                        TIM4
#define GENERAL_TIM_RCC_CLK_ENABLE()        __HAL_RCC_TIM4_CLK_ENABLE()
#define GENERAL_TIM_IRQn                    TIM4_IRQn
#define GENERAL_TIM_FUN                     TIM4_IRQHandler

// 嶨ʱԤƵʱʵʱƵΪ200MHz/GENERAL_TIMx_PRESCALER+1
#define GENERAL_TIM_PRESCALER            1999  // ʵʱƵΪ20MHz

// 嶨ʱڣʱʼGENERAL_TIMx_PERIODֵǸ¶ʱɶӦ¼ж
#define GENERAL_TIM_PERIOD               0x7FFF  // ʱжƵΪ20MHz/(0x8000)=610Hz

#endif

#ifdef USE_TIM5
/******************** ͨöʱTIM壬TIM5 *****************************/

#define GENERAL_TIMx                        TIM5
#define GENERAL_TIM_RCC_CLK_ENABLE()        __HAL_RCC_TIM5_CLK_ENABLE()
#define GENERAL_TIM_IRQn                    TIM5_IRQn
#define GENERAL_TIM_FUN                     TIM5_IRQHandler

// 嶨ʱԤƵʱʵʱƵΪ200MHz/GENERAL_TIMx_PRESCALER+1
#define GENERAL_TIM_PRESCALER            199  // ʵʱƵΪ1MHz

// 嶨ʱڣʱʼGENERAL_TIMx_PERIODֵǸ¶ʱɶӦ¼ж
#define GENERAL_TIM_PERIOD               0xFFFF  // ʱжƵΪ20MHz/(0x8000)=610Hz

#endif

#define STEPMOTOR_TIM_CHANNEL_1          TIM_CHANNEL_1
#define STEPMOTOR_TIM_CHANNEL_2          TIM_CHANNEL_2

/* º궨жTIMx ǷΪģʽ,
 * ݹܿͼ,TRGOźŵĶʱ
 */
#define IS_TIMx_MASTER(INSTANCE)       (((INSTANCE) == TIM1)  || \
                                       ((INSTANCE) == TIM2)   || \
                                       ((INSTANCE) == TIM3)   || \
                                       ((INSTANCE) == TIM4)   || \
                                       ((INSTANCE) == TIM5)   || \
                                       ((INSTANCE) == TIM6)   || \
                                       ((INSTANCE) == TIM7)   || \
                                       ((INSTANCE) == TIM8)   || \
                                       ((INSTANCE) == TIM12)  || \
                                       ((INSTANCE) == TIM15))
/* º궨жTIMx  ǷжʱԴ,
 * ݶʱܿͼ,ITRxѡԴĶʱ
 */
#define IS_TIMx_MULTISOURCE(INSTANCE)  (((INSTANCE) == TIM1)   || \
                                       ((INSTANCE) == TIM2)    || \
                                       ((INSTANCE) == TIM3)    || \
                                       ((INSTANCE) == TIM4)    || \
                                       ((INSTANCE) == TIM5)    || \
                                       ((INSTANCE) == TIM8)    || \
                                       ((INSTANCE) == TIM12)   || \
                                       ((INSTANCE) == TIM15))
																			 

/* չ ------------------------------------------------------------------*/
extern TIM_HandleTypeDef htim5;

/*  ------------------------------------------------------------------*/
void GENERAL_TIMx_Init(void);

#endif	/* __GENERAL_TIM_H__ */
/**** (C) COPYRIGHT 2019-2030 ӲʯǶʽŶ *******END OF FILE************/


