/**
  ******************************************************************************
  * ļ: bsp_RS485.h 
  *     : ӲʯǶʽŶ
  *     : V1.0
  * д: 2018-09-01
  *     : UART-API
  ******************************************************************************
  * ˵
  * Ӳʯstm32YS-H7Multiʹá
  * 
  * Ա
  * ̳http://www.ing10bbs.com
  * ȨӲʯǶʽŶУá
  ******************************************************************************
  */
#ifndef __BSP_RS485_H__
#define __BSP_RS485_H__

/* ͷļ ----------------------------------------------------------------*/
#include "stm32h7xx_hal.h"

/* 궨 --------------------------------------------------------------------*/
#define MX_RS485_UART8                              UART8
#define MX_RS485_UART8_BAUDRATE                     115200

#define MX_RS485_UART8_RCC_CLK_ENABLE()              __HAL_RCC_UART8_CLK_ENABLE()
#define MX_RS485_UART8_GPIO_AFx                     GPIO_AF8_UART8

#define MX_RS485_UART8_Tx_GPIO_ClK_ENABLE()         __HAL_RCC_GPIOE_CLK_ENABLE()
#define MX_RS485_UART8_Tx_GPIO_PIN                  GPIO_PIN_1
#define MX_RS485_UART8_Tx_GPIO                      GPIOE

#define MX_RS485_UART8_Rx_GPIO_ClK_ENABLE()         __HAL_RCC_GPIOE_CLK_ENABLE()
#define MX_RS485_UART8_Rx_GPIO_PIN                  GPIO_PIN_0
#define MX_RS485_UART8_Rx_GPIO                      GPIOE

#define MX_RS485_UART8_IRQn                         UART8_IRQn
#define MX_RS485_UART8_IRQHandler                   UART8_IRQHandler

/* RTUͨҪȷʱʱ */
#if MX_RS485_UARTx_BAUDRATE<= 19200
  /* 1.5ַĳʱʱ T = BAUDRATE/11/1000*/
  #define OVERTIME_15CHAR             (1.5f*1000000/((float)MX_RS485_UARTx_BAUDRATE/11))
  /* 3ַĳʱʱ */
  #define OVERTIME_35CHAR             (3.5f*1000000/((float)MX_RS485_UARTx_BAUDRATE/11))
#else 
  /* ʳ19200bit/s½ĳʱʱ */
  #define OVERTIME_15CHAR                750.0f    // 750us 
  #define OVERTIME_35CHAR               1750.0f    // 1.75ms  
  
#endif
	
/* չ ------------------------------------------------------------------*/
extern UART_HandleTypeDef huart8_RS485;
extern __IO uint8_t Rx_Buf[256];    // ջ,256ֽ
extern __IO uint8_t Tx_Buf[256];    // ջ,256ֽ
extern __IO uint8_t tmp_Rx_Buf;     // ջ
extern  __IO uint16_t RxCount;      // ַ
  
/*  ------------------------------------------------------------------*/
void RS485_UART8_Init(void);
void UART8_Tx(uint8_t *Tx_Buf,uint16_t TxCount);

#endif /* __BSP_RS485_H__ */


