/**
  ******************************************************************************
  * ļ: main.c 
  *     : ӲʯǶʽŶ
  *     : V1.0
  * д: 2018-09-01
  *     : KEY-API
  ******************************************************************************
  * ˵
  * Ӳʯstm32YS-H7Multiʹá
  * 
  * Ա
  * ̳http://www.ing10bbs.com
  * ȨӲʯǶʽŶУá
  ******************************************************************************
  */

#ifndef __BSP_KEY_H_
#define __BSP_KEY_H_

/* ͷļ ----------------------------------------------------------------*/
#include "stm32h7xx_hal.h"

/* Ͷ ------------------------------------------------------------------*/

/* 궨 --------------------------------------------------------------------*/

#define KEY_ON                        1
#define KEY_OFF                       0

#define KEY1_DOWNSTATE                0          /* ԭͼƣKEY1ʱΪ͵ƽΪ0 */
#define KEY2_DOWNSTATE                0          /* ԭͼƣKEY2ʱΪ͵ƽΪ0 */
#define KEY3_DOWNSTATE                0          /* ԭͼƣKEY3ʱΪ͵ƽΪ0 */
#define KEY4_DOWNSTATE                0          /* ԭͼƣKEY4ʱΪ͵ƽΪ0 */
#define KEY5_DOWNSTATE                0          /* ԭͼƣKEY5ʱΪ͵ƽΪ0 */

/* GPIOʼ */
#define KEY1_RCC_CLK_ENABLE           __HAL_RCC_GPIOI_CLK_ENABLE
#define KEY1_GPIO_PIN                 GPIO_PIN_8
#define KEY1_GPIO                     GPIOI
#define KEY1_DOWN_LEVEL               GPIO_PIN_RESET /* ԭͼKEY1ʱΪ͵ƽ
                                                        Ϊ0 */
#define KEY2_RCC_CLK_ENABLE           __HAL_RCC_GPIOC_CLK_ENABLE
#define KEY2_GPIO_PIN                 GPIO_PIN_13
#define KEY2_GPIO                     GPIOC
#define KEY2_DOWN_LEVEL               GPIO_PIN_RESET /* ԭͼKEY2ʱΪ͵ƽ
                                                        Ϊ0 */
#define KEY3_RCC_CLK_ENABLE           __HAL_RCC_GPIOI_CLK_ENABLE
#define KEY3_GPIO_PIN                 GPIO_PIN_10
#define KEY3_GPIO                     GPIOI
#define KEY3_DOWN_LEVEL               GPIO_PIN_RESET /* ԭͼKEY3ʱΪ͵ƽ
                                                        Ϊ0 */
#define KEY4_RCC_CLK_ENABLE           __HAL_RCC_GPIOI_CLK_ENABLE
#define KEY4_GPIO_PIN                 GPIO_PIN_11
#define KEY4_GPIO                     GPIOI
#define KEY4_DOWN_LEVEL               GPIO_PIN_RESET /* ԭͼKEY4ʱΪ͵ƽ
                                                        Ϊ0 */
/* չ ------------------------------------------------------------------*/



uint8_t GetPinStateOfKey2(void);
uint8_t GetPinStateOfKey3(void);
uint8_t GetPinStateOfKey4(void);


/* ------------------------û ----------------------------------*/

/*ʹûݣÿһһԹûʹã
 *ڸĳ0ɣҪþ͸ĳ1˷һ
 *ڵڴ
 */
#define USER_DATA_EN			0

#define KEY_WOBBLE_TIME		10      //ʱ䡣Ҳʱ,λms
 
#define KEY_FIXED_PERIOD	10      //̶Ƶʵð״̬º,ΪڣڵλΪms

//ص
typedef  uint8_t    (*KEY_CALLBACK_PTR)(void);

#define KEY_TIMES_MAX (0XFF)
typedef enum{
	KEY_ACCESS_READ = 0,   //ĬǶȡ
	KEY_ACCESS_WRITE_CLEAR = 0x01
}ACCESS_TYPE;

/************ݾҪģֱʹü*******************************/
typedef enum
{
	KEY_DOWN 				= 1,
	KEY_UP	 				= 2,
	KEY_UP_WOBBLE 	= 3,//ȷϵ״̬
	KEY_DOWN_WOBBLE = 4 //ȷϰ״̬
}KEY_STATE;

typedef enum
{
	CHANGED 				    = 1,
	NOT_CHANGED	 				= 2,
}KEY_STATE_CHAGE;

typedef struct
{
	KEY_CALLBACK_PTR    GetStatePtr;	//ڻȡ״̬ĺ 
	uint8_t     				Times;				//²1ʹúӦó1
  KEY_STATE		        State;
  KEY_STATE_CHAGE     StateChange;                      
#ifdef KEY_FIXED_PERIOD
	unsigned char				Time_ms;			//ڹ̶ڵ״̬ºļʱ
#endif
  
#if USER_DATA_EN>0             
	uint8_t				      User_Data;		//ûûʹ
#endif
  
}KEY;


/*				*/
void KeyCreate(KEY *p_Key,KEY_CALLBACK_PTR p_CallBack);
uint8_t Key_AccessState(KEY* p_Key,KEY_STATE *p_State);

#endif /* __BSP_KEY_H_ */

/********** (C) COPYRIGHT 2019-2030 ӲʯǶʽŶ *******END OF FILE******/
