/* ͷļ ----------------------------------------------------------------*/
#include "bsp_CAN.h"


/* ˽Ͷ --------------------------------------------------------------*/
int16_t real_current[332] = {0} ;
int16_t real_velocity[332] = {0};
int32_t real_position[332] = {0};
/* ˽к궨 ----------------------------------------------------------------*/
/* ˽б ------------------------------------------------------------------*/

FDCAN_HandleTypeDef hFDCan1;
FDCAN_RxHeaderTypeDef FDCAN1_Rx;
FDCAN_TxHeaderTypeDef FDCAN1_Tx;

FDCAN_HandleTypeDef hFDCan2;
FDCAN_RxHeaderTypeDef FDCAN2_Rx;
FDCAN_TxHeaderTypeDef FDCAN2_Tx;

/* չ ------------------------------------------------------------------*/
/* ˽кԭ --------------------------------------------------------------*/
/*  --------------------------------------------------------------------*/
/**
  * : CANųʼ
  * : 
  *   ֵ: 
  * ˵    : 
  */
void CAN1_MspInit(void)
{

  GPIO_InitTypeDef GPIO_InitStruct={0};

  /* ʹԼGPIOʱ */
  CAN1_CLK_ENABLE();
  CAN1_GPIO_CLK_ENABLE();
  
  /**FDCAN1 GPIO Configuration    
  PI9     ------> FDCAN1_RX
  PB9     ------> FDCAN1_TX 
  */
  GPIO_InitStruct.Pin = CAN1_TX_PIN;
  GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Alternate=GPIO_AFx_CAN;
  HAL_GPIO_Init(CAN1_TX_GPIO_PORT, &GPIO_InitStruct);

  GPIO_InitStruct.Pin = CAN1_RX_PIN;
  GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_HIGH;
  GPIO_InitStruct.Alternate=GPIO_AFx_CAN;
  HAL_GPIO_Init(CAN1_RX_GPIO_PORT, &GPIO_InitStruct);

  HAL_NVIC_SetPriority(FDCAN1_IT0_IRQn, 3, 0);
  HAL_NVIC_EnableIRQ(FDCAN1_IT0_IRQn);  
    
}

/**
  * : CANʼ
  * : 
  *   ֵ: 
  * ˵    : 
  */
/**
  * : CANʼ
  * : 
  *   ֵ: 
  * ˵    : 
  */
void MX_CAN1_Init(void)
{ 
  FDCAN_FilterTypeDef FDCAN_RXFilter={0};        
  /*CANųʼ*/
  CAN1_MspInit();
  
  /*CANԪʼ*/ 
  HAL_FDCAN_DeInit(&hFDCan1);                              //ǰ
  hFDCan1.Instance = FDCAN1;
  hFDCan1.Init.FrameFormat = FDCAN_FRAME_CLASSIC;           //FDģʽ  
  hFDCan1.Init.Mode = FDCAN_MODE_NORMAL;                   //ͨģʽ
  hFDCan1.Init.AutoRetransmission = DISABLE;               //رԶشͳģʽ¹ر
  hFDCan1.Init.TransmitPause = DISABLE;                    //رմͣ    
  hFDCan1.Init.ProtocolException=DISABLE;                  //رЭ쳣
  hFDCan1.Init.NominalPrescaler = 2;                       //Ƶϵ
  hFDCan1.Init.NominalSyncJumpWidth = 0x1;                 //ͬԾ
  hFDCan1.Init.NominalTimeSeg1 = 0xF;                      //֮ǰ־ʱ:2~256
  hFDCan1.Init.NominalTimeSeg2 = 0x4;                      //֮־ʱ:2~128
  hFDCan1.Init.DataPrescaler = 2;                          //ݶԤƵ
  hFDCan1.Init.DataSyncJumpWidth = 0x4;                    //λͬԾ
  hFDCan1.Init.DataTimeSeg1 = 0xF;                         //֮ǰʱ
  hFDCan1.Init.DataTimeSeg2 = 0x4;                         //֮ʱ
  hFDCan1.Init.MessageRAMOffset = 0;                       //ָϢRAMʼַ
  hFDCan1.Init.StdFiltersNbr = 1;                          //׼ϢID˲
  hFDCan1.Init.ExtFiltersNbr = 0;                          //չϢID˲
  hFDCan1.Init.RxFifo0ElmtsNbr = 1;                        //FIFO0Ԫر
  hFDCan1.Init.RxFifo0ElmtSize = FDCAN_DATA_BYTES_8;       //FIFO0ԪشС8ֽ
  hFDCan1.Init.RxBuffersNbr = 0;                           //ջ
  hFDCan1.Init.TxEventsNbr = 0;                            //¼
  hFDCan1.Init.TxBuffersNbr = 0;                           //ͻ
  hFDCan1.Init.TxFifoQueueElmtsNbr = 1;                    //FIFOԪر
  hFDCan1.Init.TxFifoQueueMode = FDCAN_TX_FIFO_OPERATION;  //FIFOģʽ
  hFDCan1.Init.TxElmtSize = FDCAN_DATA_BYTES_8;            //ʹС:8ֽ
  
  HAL_FDCAN_Init(&hFDCan1);

  /* RX˲ */
  FDCAN_RXFilter.IdType=FDCAN_STANDARD_ID;                //׼ID
  FDCAN_RXFilter.FilterIndex=0;                           //˲                   
  FDCAN_RXFilter.FilterType=FDCAN_FILTER_MASK;            //˲
  FDCAN_RXFilter.FilterConfig=FDCAN_FILTER_TO_RXFIFO0;    //0FIFO1  
  FDCAN_RXFilter.FilterID1=0x112;                         //32λID1
  FDCAN_RXFilter.FilterID2=0x112;                         //32λID2
  if(HAL_FDCAN_ConfigFilter(&hFDCan1,&FDCAN_RXFilter)!=HAL_OK)
  {
     printf("˲ʼʧ\n");
  }

  /* ý FIFO 0 watermark Ϊ 2 */
  HAL_FDCAN_ConfigFifoWatermark(&hFDCan1, FDCAN_CFG_RX_FIFO0, 2);
  
  /* FDCAN */
  HAL_FDCAN_Start(&hFDCan1);                               
  
  /* ʹFDCANж */
  HAL_FDCAN_ActivateNotification(&hFDCan1,FDCAN_IT_RX_FIFO0_NEW_MESSAGE,0);
  	
}

/**
  * : һ
  * : len:ݳ(Ϊ8)
              msg:ָ,Ϊ8ֽ
  *   ֵ: 0,ɹ;ʧ
  * ˵    : IDΪ0X12,׼֡,֡
  */
uint8_t FDCAN1_Send_Msg(int can_id , uint8_t* msg)
{	           
  FDCAN1_Tx.Identifier= can_id;                             //32λID
  FDCAN1_Tx.IdType=FDCAN_STANDARD_ID;                     //׼ID
  FDCAN1_Tx.TxFrameType=FDCAN_DATA_FRAME;                 //֡
  FDCAN1_Tx.DataLength=FDCAN_DLC_BYTES_8;                 //ݳ
  FDCAN1_Tx.ErrorStateIndicator=FDCAN_ESI_ACTIVE;             
  FDCAN1_Tx.BitRateSwitch=FDCAN_BRS_ON;                  //رл
  FDCAN1_Tx.FDFormat=FDCAN_CLASSIC_CAN;                   //CANģʽ                   
  FDCAN1_Tx.TxEventFifoControl=FDCAN_NO_TX_EVENTS;       //޷¼
  FDCAN1_Tx.MessageMarker=0;    	
  /* Ҫ͵ѹ뵽TX FIFO */
  HAL_FDCAN_AddMessageToTxFifoQ(&hFDCan1,&FDCAN1_Tx,msg);
	
  return 0;
}

/**
  * : CANųʼ
  * : 
  *   ֵ: 
  * ˵    : 
  */
void CAN2_MspInit(void)
{

  GPIO_InitTypeDef GPIO_InitStruct={0};

  /* ʹԼGPIOʱ */
  CAN2_CLK_ENABLE();
  CAN2_GPIO_CLK_ENABLE();
  
  /**FDCAN2 GPIO Configuration    
  PB5     ------> FDCAN2_RX
  PB6     ------> FDCAN2_TX 
  */
  GPIO_InitStruct.Pin = CAN2_TX_PIN;
  GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Alternate=GPIO_AFy_CAN;
  HAL_GPIO_Init(CAN2_TX_GPIO_PORT, &GPIO_InitStruct);

  GPIO_InitStruct.Pin = CAN2_RX_PIN;
  GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_HIGH;
  GPIO_InitStruct.Alternate=GPIO_AFy_CAN;
  HAL_GPIO_Init(CAN2_RX_GPIO_PORT, &GPIO_InitStruct);

  HAL_NVIC_SetPriority(FDCAN2_IT0_IRQn, 3, 0);
  HAL_NVIC_EnableIRQ(FDCAN2_IT0_IRQn);  
    
}

/**
  * : CANʼ
  * : 
  *   ֵ: 
  * ˵    : 
  */
void MX_CAN2_Init(void)
{ 
  FDCAN_FilterTypeDef FDCAN_RXFilter={0};        
  /*CANųʼ*/
  CAN2_MspInit();
  
  /*CANԪʼ*/ 
  HAL_FDCAN_DeInit(&hFDCan2);                              //ǰ
  hFDCan2.Instance = FDCAN2;
  hFDCan2.Init.FrameFormat = FDCAN_FRAME_CLASSIC;           //FDģʽ  
  hFDCan2.Init.Mode = FDCAN_MODE_NORMAL;                   //ͨģʽ
  hFDCan2.Init.AutoRetransmission = DISABLE;               //رԶشͳģʽ¹ر
  hFDCan2.Init.TransmitPause = DISABLE;                    //رմͣ    
  hFDCan2.Init.ProtocolException=DISABLE;                  //رЭ쳣
  hFDCan2.Init.NominalPrescaler = 2;                       //Ƶϵ
  hFDCan2.Init.NominalSyncJumpWidth = 0x1;                 //ͬԾ
  hFDCan2.Init.NominalTimeSeg1 = 0xF;                      //֮ǰ־ʱ:2~256
  hFDCan2.Init.NominalTimeSeg2 = 0x4;                      //֮־ʱ:2~128
  hFDCan2.Init.DataPrescaler = 2;                          //ݶԤƵ
  hFDCan2.Init.DataSyncJumpWidth = 0x4;                    //λͬԾ
  hFDCan2.Init.DataTimeSeg1 = 0xF;                         //֮ǰʱ
  hFDCan2.Init.DataTimeSeg2 = 0x4;                         //֮ʱ
  hFDCan2.Init.MessageRAMOffset = 0;                       //ָϢRAMʼַ
  hFDCan2.Init.StdFiltersNbr = 1;                          //׼ϢID˲
  hFDCan2.Init.ExtFiltersNbr = 0;                          //չϢID˲
  hFDCan2.Init.RxFifo0ElmtsNbr = 1;                        //FIFO0Ԫر
  hFDCan2.Init.RxFifo0ElmtSize = FDCAN_DATA_BYTES_8;       //FIFO0ԪشС8ֽ
  hFDCan2.Init.RxBuffersNbr = 0;                           //ջ
  hFDCan2.Init.TxEventsNbr = 0;                            //¼
  hFDCan2.Init.TxBuffersNbr = 0;                           //ͻ
  hFDCan2.Init.TxFifoQueueElmtsNbr = 1;                    //FIFOԪر
  hFDCan2.Init.TxFifoQueueMode = FDCAN_TX_FIFO_OPERATION;  //FIFOģʽ
  hFDCan2.Init.TxElmtSize = FDCAN_DATA_BYTES_8;            //ʹС:8ֽ
  
  HAL_FDCAN_Init(&hFDCan2);

  /* RX˲ */
  FDCAN_RXFilter.IdType=FDCAN_STANDARD_ID;                //׼ID
  FDCAN_RXFilter.FilterIndex=0;                           //˲                   
  FDCAN_RXFilter.FilterType=FDCAN_FILTER_MASK;             //˲
  FDCAN_RXFilter.FilterConfig=FDCAN_FILTER_TO_RXFIFO0;    //0FIFO1  
  FDCAN_RXFilter.FilterID1=0x111;                         //32λID1
  FDCAN_RXFilter.FilterID2=0x111;                         //32λID2
  if(HAL_FDCAN_ConfigFilter(&hFDCan2,&FDCAN_RXFilter)!=HAL_OK)
  {
     printf("˲ʼʧ\n");
  }

  /* ý FIFO 0 watermark Ϊ 2 */
  HAL_FDCAN_ConfigFifoWatermark(&hFDCan2, FDCAN_CFG_RX_FIFO0, 2);
  
  /* FDCAN */
  HAL_FDCAN_Start(&hFDCan2);                               
  /* ʹFDCANж */
  HAL_FDCAN_ActivateNotification(&hFDCan2,FDCAN_IT_RX_FIFO0_NEW_MESSAGE,0);
  
}




/**
  * : һ
  * : len:ݳ(Ϊ8)
              msg:ָ,Ϊ8ֽ
  *   ֵ: 0,ɹ;ʧ
  * ˵    : IDΪ0X12,׼֡,֡
  */
uint8_t FDCAN2_Send_Msg(uint8_t can_id , uint8_t* msg)
{	                   
  FDCAN2_Tx.Identifier= can_id;                             //32λID
  FDCAN2_Tx.IdType=FDCAN_STANDARD_ID;                     //׼ID
  FDCAN2_Tx.TxFrameType=FDCAN_DATA_FRAME;                 //֡
  FDCAN2_Tx.DataLength=FDCAN_DLC_BYTES_8;                 //ݳ
  FDCAN2_Tx.ErrorStateIndicator=FDCAN_ESI_ACTIVE;             
  FDCAN2_Tx.BitRateSwitch=FDCAN_BRS_ON;                  //رл
  FDCAN2_Tx.FDFormat=FDCAN_CLASSIC_CAN;                   //CANģʽ                   
  FDCAN2_Tx.TxEventFifoControl=FDCAN_NO_TX_EVENTS;       //޷¼
  FDCAN2_Tx.MessageMarker=0;   	
  /* Ҫ͵ѹ뵽TX FIFO */
  HAL_FDCAN_AddMessageToTxFifoQ(&hFDCan2,&FDCAN2_Tx,msg);
	
  return 0;
}

/**
  * : CANջص
  * : RxFifo0ITsر־λ
  *   ֵ: 
  * ˵    : 
  */
void HAL_FDCAN_RxFifo0Callback(FDCAN_HandleTypeDef *hfdcan, uint32_t RxFifo0ITs)
{
  uint8_t i=0;
  uint8_t rxdata[8];
	if(hfdcan->Instance == FDCAN1)
	{
		if((RxFifo0ITs&FDCAN_IT_RX_FIFO0_NEW_MESSAGE)!=RESET)   //FIFO1ж
		{
				/* ȡFIFO0нյ */
				HAL_FDCAN_GetRxMessage(hfdcan,FDCAN_RX_FIFO0,&FDCAN1_Rx,rxdata);
				printf("CAN1\n");
				printf("id:%#x\r\n",FDCAN1_Rx.Identifier);
				printf("len:%d\r\n",FDCAN1_Rx.DataLength>>16);
				for(i=0;i<8;i++)
				printf("rxdata[%d]:  %d\r\n",i,rxdata[i]);
			  real_current[FDCAN1_Rx.Identifier] = ((rxdata[0])<<8|rxdata[1]);
	      real_velocity[FDCAN1_Rx.Identifier] = ((rxdata[2])<<8|rxdata[3]);
	      real_position[FDCAN1_Rx.Identifier] = ((rxdata[4])<<24|rxdata[5]<<16|rxdata[6]<<8|rxdata[7]);
				HAL_FDCAN_ActivateNotification(hfdcan,FDCAN_IT_RX_FIFO0_NEW_MESSAGE,0);
		}
	}
	if(hfdcan->Instance == FDCAN2)
	{
		if((RxFifo0ITs&FDCAN_IT_RX_FIFO0_NEW_MESSAGE)!=RESET)   //FIFO1ж
		{
				/* ȡFIFO0нյ */
				HAL_FDCAN_GetRxMessage(hfdcan,FDCAN_RX_FIFO0,&FDCAN2_Rx,rxdata);
				printf("CAN2\n");
				printf("id:%#x\r\n",FDCAN2_Rx.Identifier);
				printf("len:%d\r\n",FDCAN2_Rx.DataLength>>16);
				for(i=0;i<8;i++)
				printf("rxdata[%d]:  %d\r\n",i,rxdata[i]);
				HAL_FDCAN_ActivateNotification(hfdcan,FDCAN_IT_RX_FIFO0_NEW_MESSAGE,0);
		}		
	}
}
