/* ͷļ ----------------------------------------------------------------*/
#include "bsp_usart1.h"

/* ˽Ͷ --------------------------------------------------------------*/
UART_HandleTypeDef husart1;
RingBufferTypeDef Robot_buf;
/* ˽к궨 ----------------------------------------------------------------*/

/* ˽б ------------------------------------------------------------------*/

/* չ ------------------------------------------------------------------*/

/* ˽кԭ --------------------------------------------------------------*/

/*  --------------------------------------------------------------------*/

/**
  * : شųʼ
  * : 
  *   ֵ: 
  * ˵    : ʼ
  */
static void UART1_MspInit(void)
{
  GPIO_InitTypeDef GPIO_InitStruct={0};

  /* USART ʱʹ */
  MX_USART1_RCC_CLK_ENABLE();
  /*  ʱʹ */
  MX_USART1_Tx_GPIO_ClK_ENABLE();
	MX_USART1_Rx_GPIO_ClK_ENABLE();
  
  /* USART GPIO : ùģʽ  */
  GPIO_InitStruct.Pin = MX_USART1_Tx_GPIO_PIN;
  GPIO_InitStruct.Mode = GPIO_MODE_AF_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_VERY_HIGH;
  GPIO_InitStruct.Alternate = MX_USART1_GPIO_AFx;
  HAL_GPIO_Init(MX_USART1_Tx_GPIO, &GPIO_InitStruct);
	
	GPIO_InitStruct.Pin = MX_USART1_Rx_GPIO_PIN;
  HAL_GPIO_Init(MX_USART1_Rx_GPIO, &GPIO_InitStruct);
    
  /* NVICôжȼ*/
  HAL_NVIC_SetPriority(MX_USART1_IRQn, 0, 0);
	/* NVICʹܴж*/
  HAL_NVIC_EnableIRQ(MX_USART1_IRQn);
}

/**
  * : شͨųʼ
  * : 
  *   ֵ: 
  * ˵    : ʼͨŹ
  */
void USART1_Init(void)
{
  /* ͨGPIOʼ */
  UART1_MspInit();
  /* ͨŹ */
  husart1.Instance = MX_USART1;                                   // ں
  husart1.Init.BaudRate   = MX_USART1_BAUDRATE;                   // 
  husart1.Init.WordLength = UART_WORDLENGTH_8B;                   // Чݳ
  husart1.Init.StopBits   = UART_STOPBITS_1;                      // ֹͣλ
  husart1.Init.Parity     = UART_PARITY_NONE;                     // żУ
  husart1.Init.Mode       = UART_MODE_TX_RX;                      // &ģʽ
  husart1.Init.HwFlowCtl  = UART_HWCONTROL_NONE;                  // Ӳ
  husart1.Init.OverSampling    = UART_OVERSAMPLING_16;            // 
  husart1.Init.OneBitSampling  = UART_ONE_BIT_SAMPLE_DISABLE;     // λ
  husart1.Init.Prescaler       = UART_PRESCALER_DIV1;             // ԤƵϵ
  husart1.Init.FIFOMode        = UART_FIFOMODE_DISABLE;           // FIFOģʽ
  husart1.Init.TXFIFOThreshold = UART_TXFIFO_THRESHOLD_1_8;       // FIFOֵ
  husart1.Init.RXFIFOThreshold = UART_RXFIFO_THRESHOLD_1_8;       // FIFOֵ  
  husart1.AdvancedInit.AdvFeatureInit = UART_ADVFEATURE_NO_INIT;  // ߼Ӧù
  HAL_UART_Init(&husart1);
}

/* ͵ֽ */
void Usart_SendByte(uint8_t ch)
{
    /* һֽڵUSART */
    HAL_UART_Transmit(&husart1,&ch,1,1);
	/* ȴͼĴΪ */
}

/* 8λֽ */
void Usart_SendByteArr(uint8_t *byteArr, uint16_t size){
    uint16_t bidx;
    for (bidx=0; bidx<size; bidx++){
        Usart_SendByte(byteArr[bidx]);
    }
    /* ȴͼĴΪ */
    // while (USART_GetFlagStatus(pUSARTx, USART_FLAG_TXE) == RESET);	
}

/* ַ */
void Usart_SendString(char *str){
    uint16_t sidx=0;
    do
    {
        Usart_SendByte((uint8_t)(*(str + sidx)));
        sidx++;
    } while(*(str + sidx) != '\0');
    /* ȴͼĴΪ */
	// USART_FLAG_TXE:  Transmit data register empty flag ݼĴΪ
	// RESET = 0
	// SET = 1																																						
    // while (USART_GetFlagStatus(pUSARTx, USART_FLAG_TXE) == RESET);
}

// ڷͻȫȥ
void Usart_SendAll(void){
	uint8_t value;
	while(RingBuffer_GetByteUsed(&Robot_buf)){
		value = RingBuffer_Pop(&Robot_buf);
		// printf("Usart_SendAll pop: %d", value);
		Usart_SendByte(value);
	}
}

