#include "imu.h"


extern __IO uint16_t RxCount4;                  // ѽյֽ
extern __IO uint8_t Frame_flag4;                // ֡־1һµ֡  0֡ 

int angular_x_speed,angular_y_speed,angular_z_speed = 0;
int Euler_x_angles,Euler_y_angles,Euler_z_angles= 0;
int Roll,Pitch,Yaw=0;
int qw,qx,qy,qz=0;


extern uint8_t IMU_aRxBuffer[256];
IMU_State imu_data_ch110;


uint8_t imu_rbuf[82] ={0x00};
uint8_t imu_rbuf_data[82] ={0};
int imu_step = 0;
extern uint8_t  hand_step_imu;

uint32_t payload_len;
uint16_t crc = 0;
uint16_t imu_rbuf_crc = 0;

__align(4) id0x91_t imu_data; /* struct must be 4 byte aligned */


/************
ܣcrcУ
***********/
static void crc16_update(uint16_t *currectCrc, const uint8_t *src,uint32_t lengthInBytes)
{
		uint32_t crc = *currectCrc;
		uint32_t j;
		for (j=0; j < lengthInBytes; ++j)
		{
		 uint32_t i;
		 uint32_t byte = src[j];
		 crc ^= byte << 8;
			for (i = 0; i < 8; ++i)
			{
				uint32_t temp = crc << 1;
				if (crc & 0x8000)
				{
				temp ^= 0x1021;
				}
				crc = temp;
			}
		}
		*currectCrc = crc;
}
/************
ܣ޸imu
룺imu_id Ĭ0x608
; 
***********/
void imu_baud(int Imu_id ,int baud)
{
   

}
/************
ܣ޸imu
룺imu_id Ĭ0x608
룺ǰҪ޸ĵģʽ
룺ǰ޸ģʽҪ

***********/
void imu_data_rate(int Imu_id , int imu_model ,int data_rate)
{

	
	  
}






/************
ܣimu



***********/

void IMU_Status(void)
{ 
	if(Frame_flag4)  // յһ֡
	{
		 RxCount4=0;    // ֽڼ
   	 Frame_flag4=0; // ֡	
		 if((IMU_aRxBuffer[0]==0x5A)&&(IMU_aRxBuffer[1]==0xA5))
		 {
			payload_len = IMU_aRxBuffer[2] + (IMU_aRxBuffer[3] << 8);
			imu_rbuf_crc =  IMU_aRxBuffer[4] + (IMU_aRxBuffer[5] << 8);
			/* calulate 5A A5 and LEN filed crc */
			crc16_update(&crc, IMU_aRxBuffer, 4);
			/* calulate payload crc */	
			crc16_update(&crc, IMU_aRxBuffer + 6, payload_len);
			if(crc==imu_rbuf_crc)
			{
			 memcpy(&imu_data, &IMU_aRxBuffer[6], sizeof(id0x91_t));
			 imu_data_ch110.accel_x = imu_data.acc[0]*9.8f;
			 imu_data_ch110.accel_y	= imu_data.acc[1]*9.8f;
			 imu_data_ch110.accel_z = imu_data.acc[2]*9.8f;
			 
			 imu_data_ch110.gyro_x = imu_data.gyr[0];
			 imu_data_ch110.gyro_y = imu_data.gyr[1];
			 imu_data_ch110.gyro_z = imu_data.gyr[2];
				
			 imu_data_ch110.q1 = imu_data.quat[0];
			 imu_data_ch110.q2 = imu_data.quat[1];
			 imu_data_ch110.q3 = imu_data.quat[2];
			 imu_data_ch110.q4 = imu_data.quat[3];
				
			 imu_data_ch110.eular_roll = imu_data.eul[0];
			 imu_data_ch110.eular_pitch = imu_data.eul[1];
			 imu_data_ch110.eular_yaw = imu_data.eul[2];	
		 
		  }
		 
		 }
		
		
		
		
		
	}
 
}



