#include "motor_servo.h"

Motor_status Motor[4];

char data[8]={0x00};//ַ
long int  Filter[28]; 

 extern int16_t real_current[332] ;
 extern int16_t real_velocity[332];
 extern int32_t real_position[332];

uint8_t motor_servo_tx[8]={0x00};


/*****
ܣλ
㲥λ
룺id 
*******/
void motor_init(int Motor_id)
{  
    motor_servo_tx[0]=0x55;
	  motor_servo_tx[1]=0x55;
	  motor_servo_tx[2]=0x55;
	  motor_servo_tx[3]=0x55;
	  motor_servo_tx[4]=0x55;
	  motor_servo_tx[5]=0x55;
	  motor_servo_tx[6]=0x55;
	  motor_servo_tx[7]=0x55;
	  
   FDCAN1_Send_Msg(Motor_id , motor_servo_tx);
	  
	 
}
/*** 
ܣģʽѡ
룺ģʽ
***/
void motor_control(int Motor_id,int Motor_servo_mode)
{  
   switch( Motor_servo_mode)
	{
	 case open_loop :  motor_servo_tx[0]= open_loop; break;
	 case current :    motor_servo_tx[0]= current;   break;
	 case career:      motor_servo_tx[0]= career;    break;
	 case pos :        motor_servo_tx[0]= pos;       break;
	 case career_pos :    motor_servo_tx[0]= career_pos;   break;
	 case current_career:      motor_servo_tx[0]= current_career;    break;
	 case current_pos :  motor_servo_tx[0]= current_pos; break;
	 case current_career_pos :    motor_servo_tx[0]= current_career_pos;   break; 
	}
	 motor_servo_tx[1]=0x55;
	 motor_servo_tx[2]=0x55;
	 motor_servo_tx[3]=0x55;
	 motor_servo_tx[4]=0x55;
	 motor_servo_tx[5]=0x55;
	 motor_servo_tx[6]=0x55;
	 motor_servo_tx[7]=0x55;

	 FDCAN1_Send_Msg(Motor_id|status_choice_id , motor_servo_tx);
	 
}
/*******
ܣ
룺id
룺pwm
*******/
int Motor_open_loop_control(int Motor_id , int pwm)
{  
  motor_servo_tx[0] = (unsigned char)((pwm>>8)&0xff);
	motor_servo_tx[1] = (unsigned char)(pwm&0xff); 
	motor_servo_tx[2]=  (unsigned char)((current>>8)&0xff);
	motor_servo_tx[3]=  (unsigned char)(current&0xff); 
	motor_servo_tx[4]=0x55;
	motor_servo_tx[5]=0x55;
	motor_servo_tx[6]=0x55;
	motor_servo_tx[7]=0x55;
  
	FDCAN1_Send_Msg(Motor_id|open_loop_id , motor_servo_tx);
	 
	 return 1;
}


/******
ܣ
룺id
룺 temp_pwm ռձ temp_pwm ȡֵΧΪ0~+5000
룺 current              temp_current ȡֵΧΪ-32768~+32767
******/
int Motor_current_control(int Motor_id,unsigned int pwm, int current)
{ 
  motor_servo_tx[0] = (unsigned char)((pwm>>8)&0xff);
	motor_servo_tx[1] = (unsigned char)(pwm&0xff); 
	motor_servo_tx[2]=  (unsigned char)((current>>8)&0xff);
	motor_servo_tx[3]=  (unsigned char)(current&0xff); 
	motor_servo_tx[4]=0x55;
	motor_servo_tx[5]=0x55;
	motor_servo_tx[6]=0x55;
	motor_servo_tx[7]=0x55;

	FDCAN1_Send_Msg(Motor_id|current_id , motor_servo_tx);
	return 1;
}


/*****
ܣٶȻ
룺pwm
룺id
룺ٶ
****/
int motor_career_control(int Motor_id,unsigned int pwm, int career)
{ 
  motor_servo_tx[0] = (unsigned char)((pwm>>8)&0xff);
	motor_servo_tx[1] = (unsigned char)(pwm&0xff); 
	motor_servo_tx[2]=  (unsigned char)((career>>8)&0xff);
	motor_servo_tx[3]=  (unsigned char)(career&0xff); 
	motor_servo_tx[4]=0x55;
	motor_servo_tx[5]=0x55;
	motor_servo_tx[6]=0x55;
	motor_servo_tx[7]=0x55;
	
  FDCAN1_Send_Msg(Motor_id|career_id, motor_servo_tx);

	return 1;
}


/****
ܣλÿ
룺id
룺λ
****/
int Motor_pos_control(int Motor_id ,unsigned int pwm , int pos)
{ 
  motor_servo_tx[0]=(unsigned char)((pwm>>8)&0xff);
	motor_servo_tx[1]=(unsigned char)(pwm&0xff); 
	motor_servo_tx[2]=0x55;
	motor_servo_tx[3]=0x55;
	motor_servo_tx[4]=(unsigned char)((pos>>24)&0xff);
	motor_servo_tx[5]=(unsigned char)((pos>>16)&0xff);
	motor_servo_tx[6]=(unsigned char)((pos>>8)&0xff);
	motor_servo_tx[7]=(unsigned char)(pos&0xff); 

  FDCAN1_Send_Msg(Motor_id|pos_id , motor_servo_tx);
	return 1;
}


/****
ܣٶλÿ
룺id
룺ٶ
룺λ

****/
int Motor_career_pos(int Motor_id ,unsigned int pwm , int career, int pos)
{ 
  motor_servo_tx[0]=(unsigned char)((pwm>>8)&0xff);
	motor_servo_tx[1]=(unsigned char)(pwm&0xff); 
	motor_servo_tx[2]=(unsigned char)((career>>8)&0xff);
	motor_servo_tx[3]=(unsigned char)(career&0xff); 
	motor_servo_tx[4]=(unsigned char)((pos>>24)&0xff);
	motor_servo_tx[5]=(unsigned char)((pos>>16)&0xff);
	motor_servo_tx[6]=(unsigned char)((pos>>8)&0xff);
	motor_servo_tx[7]=(unsigned char)(pos&0xff); 

  FDCAN1_Send_Msg(Motor_id|career_pos_id , motor_servo_tx);
	return 1;
}


/***
ܣٶ
룺id
룺
룺λ
****/
int Motor_current_career(int Motor_id , int current , int career)
{ 
  motor_servo_tx[0]=(unsigned char)((current>>8)&0xff);
	motor_servo_tx[1]=(unsigned char)(current&0xff); 
	motor_servo_tx[2]=(unsigned char)((career>>8)&0xff);
	motor_servo_tx[3]=(unsigned char)(career&0xff); 
	motor_servo_tx[4]=0x55;
	motor_servo_tx[5]=0x55;
	motor_servo_tx[6]=0x55;
	motor_servo_tx[7]=0x55;

  FDCAN1_Send_Msg(Motor_id|current_career_id , motor_servo_tx);
	return 1;
}


/****
ܣٶλÿ
룺id
룺
룺ٶ
*****/
int Motor_current_pos(int Motor_id , int current, int career)
{ 
  motor_servo_tx[0]=(unsigned char)((career>>8)&0xff);
	motor_servo_tx[1]=(unsigned char)(career&0xff); 
	motor_servo_tx[2]=0x55;
	motor_servo_tx[3]=0x55;
	motor_servo_tx[4]=(unsigned char)((pos>>24)&0xff);
	motor_servo_tx[5]=(unsigned char)((pos>>16)&0xff);
	motor_servo_tx[6]=(unsigned char)((pos>>8)&0xff);
	motor_servo_tx[7]=(unsigned char)(pos&0xff);
  
	FDCAN1_Send_Msg(Motor_id|current_pos_id , motor_servo_tx);
	return 1;
}


/****
ܣٶλÿ
룺id
룺
룺ٶ
룺λ
*****/
int Motor_current_career_pos(int Motor_id , int current, int career, int pos)
{ 
  motor_servo_tx[0]=(unsigned char)((current>>8)&0xff);
	motor_servo_tx[1]=(unsigned char)(current&0xff); 
	motor_servo_tx[2]=(unsigned char)((career>>8)&0xff);
	motor_servo_tx[3]=(unsigned char)(career&0xff); 
	motor_servo_tx[4]=(unsigned char)((pos>>24)&0xff);
	motor_servo_tx[5]=(unsigned char)((pos>>16)&0xff);
	motor_servo_tx[6]=(unsigned char)((pos>>8)&0xff);
	motor_servo_tx[7]=(unsigned char)(pos&0xff); 

  FDCAN1_Send_Msg(Motor_id|pos_id , motor_servo_tx);
	return 1;
}

/****
ܣָ
룺id
룺ǷҪ λãٶȵϢ   0x0A10ms  0x00  
룺ǷҪƽ  0x0A10ms  0x00 
*****/
int Motor_current_career_pos_dispose(int Motor_id , int motor_retroaction, int level_retroaction )
{ 
  motor_servo_tx[0]= motor_retroaction;
	motor_servo_tx[1]= level_retroaction; 
	motor_servo_tx[2]=0x55;
	motor_servo_tx[3]=0x55;
	motor_servo_tx[4]=0x55;
	motor_servo_tx[5]=0x55;
	motor_servo_tx[6]=0x55;
	motor_servo_tx[7]=0x55;
  
	FDCAN1_Send_Msg(Motor_id|Motor_configure_id, motor_servo_tx);
	return 1;
}
/*******
ܣ߼
룺id
أصǰID 
*******/
int Motor_Online_detection(int Motor_id)
{
  motor_servo_tx[0]=0x55;
	motor_servo_tx[1]=0x55; 
	motor_servo_tx[2]=0x55;
	motor_servo_tx[3]=0x55;
	motor_servo_tx[4]=0x55;
	motor_servo_tx[5]=0x55;
	motor_servo_tx[6]=0x55;
	motor_servo_tx[7]=0x55;

  FDCAN1_Send_Msg(Motor_id, motor_servo_tx);
	
	return 1;
}
/****
ܣϢ
0x11B 0x13B 


0x12B 0X14B


*****/
void Motor_status_analysis(void)
{ 
	
}

void motor_speed_status(void)
{  
   
	 //
	 Motor[0].real_current = real_current[0x11B];
	 Motor[1].real_current = real_current[0x12B];
	 Motor[2].real_current = real_current[0x13B];
	 Motor[3].real_current = real_current[0x14B];
	
	 //ٶ
	 Motor[0].real_velocity = real_velocity[0x11B];
	 Motor[1].real_velocity = real_velocity[0x12B];
	 Motor[2].real_velocity = real_velocity[0x13B];
	 Motor[3].real_velocity = real_velocity[0x14B];
	
	//λ
	 Motor[0].real_position = real_position[0x11B];
	 Motor[1].real_position = real_position[0x12B];
	 Motor[2].real_position = real_position[0x13B];
	 Motor[3].real_position = real_position[0x14B];
	

	

	
}
