#ifndef __Balance_H
#define __Balance_H

#define Omni 0

#define Mec  1

#define PI 3.1415f  //Բ

float target_limit_float(float insert,float low,float high);

int target_limit_int(int insert,int low,int high);

typedef struct  
{
  float WheelSpacing;    //־  
  float AxleSpacing;     //
  float GearRatio;       //ٱ
  int   EncoderAccuracy; //
  float WheelDiameter;   //־
}Robot_Parament_InitTypeDef;

void Robot_Init(float wheelspacing,float axlespacing,int gearratio,float tyre_diameter);

void Drive_Motor(float Vx,float Vy,float Vz);

int Incremental_PI_A (float Encoder,float Target);
int Incremental_PI_B (float Encoder,float Target);
int Incremental_PI_C (float Encoder,float Target);
int Incremental_PI_D (float Encoder,float Target);

typedef struct  
{
float Encoder;       //ֵ
float Motor_Pwm;     //PWMֵ
float Target;        //Ŀٶֵ
float Velocity_KP;   //ٶȿPID
float	Velocity_KI;   //ٶȿPID
}Motor_parameter;

typedef struct  
{
float VX;    //ƽƴ
float VY;    //ƽƴ
float VZ;    //ƽƴ
}Smooth_Control;


#endif

