
#ifndef __BSP_CAN_H__
#define __BSP_CAN_H__

/* ͷļ ----------------------------------------------------------------*/
#include "stm32h7xx_hal.h"
#include <stdio.h>

/* Ͷ ------------------------------------------------------------------*/
/* 궨 --------------------------------------------------------------------*/

#define CAN1_CLK_ENABLE()               __HAL_RCC_FDCAN_CLK_ENABLE()

#define CAN1_GPIO_CLK_ENABLE()          {__HAL_RCC_GPIOB_CLK_ENABLE();__HAL_RCC_GPIOI_CLK_ENABLE();}
#define CAN1_TX_GPIO_PORT               GPIOB
#define CAN1_TX_PIN                     GPIO_PIN_9

#define CAN1_RX_GPIO_PORT               GPIOI
#define CAN1_RX_PIN                     GPIO_PIN_9

#define GPIO_AFx_CAN                    GPIO_AF9_FDCAN1

#define FDCAN1_IT0_IRQn                 FDCAN1_IT0_IRQn
#define FDCAN1_IT0_IRQHandler           FDCAN1_IT0_IRQHandler



#define CAN2_CLK_ENABLE()               __HAL_RCC_FDCAN_CLK_ENABLE()

#define CAN2_GPIO_CLK_ENABLE()          __HAL_RCC_GPIOB_CLK_ENABLE()
#define CAN2_TX_GPIO_PORT               GPIOB
#define CAN2_TX_PIN                     GPIO_PIN_6

#define CAN2_RX_GPIO_PORT               GPIOB
#define CAN2_RX_PIN                     GPIO_PIN_5

#define GPIO_AFy_CAN                    GPIO_AF9_FDCAN2

#define FDCAN2_IT0_IRQn                 FDCAN2_IT0_IRQn
#define FDCAN2_IT0_IRQHandler           FDCAN2_IT0_IRQHandler

/* չ ------------------------------------------------------------------*/
extern FDCAN_HandleTypeDef hFDCan1;
extern FDCAN_RxHeaderTypeDef FDCAN1_Rx;
extern FDCAN_TxHeaderTypeDef FDCAN1_Tx;

extern FDCAN_HandleTypeDef hFDCan2;
extern FDCAN_RxHeaderTypeDef FDCAN2_Rx;
extern FDCAN_TxHeaderTypeDef FDCAN2_Tx;
/*  ------------------------------------------------------------------*/
void MX_CAN1_Init(void);
void MX_CAN2_Init(void);
uint8_t FDCAN1_Send_Msg(int can_id , uint8_t* msg);

uint8_t FDCAN2_Send_Msg(uint8_t can_id , uint8_t* msg);

#endif /* __BSP_CAN_H__ */


/********** (C) COPYRIGHT 2019-2030 ӲʯǶʽŶ *******END OF FILE******/
