/* ͷļ ----------------------------------------------------------------*/
#include "bsp_BasicTIM.h" 

/* ˽Ͷ --------------------------------------------------------------*/

/* ˽к궨 ----------------------------------------------------------------*/

/* ˽б ------------------------------------------------------------------*/
TIM_HandleTypeDef htim6;
volatile uint32_t ulHighFrequencyTimerTicks;

/* չ ------------------------------------------------------------------*/

/* ˽кԭ --------------------------------------------------------------*/

/*  --------------------------------------------------------------------*/

/**
  * : ʱӲʼ
  * : 
  *   ֵ: 
  * ˵    : 
  */
void TIM6_Base_MspInit(void)
{
  /* ʱʱʹ */
  BASIC_TIM_RCC_CLK_ENABLE();

  /* ж */
  HAL_NVIC_SetPriority(BASIC_TIM_IRQ, 1, 0);
  HAL_NVIC_EnableIRQ(BASIC_TIM_IRQ);
}

/**
  * : ʱʼ
  * : 
  *   ֵ: 
  * ˵    : 
  */
void BASIC_TIM6_Init(void)
{  
  TIM_ClockConfigTypeDef  sClockSourceConfig = {0};
  TIM_MasterConfigTypeDef sMasterConfig      = {0}; 
  
  /* TIMʱж */
  TIM6_Base_MspInit();
  
  htim6.Instance         = BASIC_TIMx;          // ʱ
  htim6.Init.Prescaler   = BASIC_TIMx_PRESCALER;// ԤƵ
  htim6.Init.CounterMode = TIM_COUNTERMODE_UP;  // ģʽ:ϼ
  htim6.Init.Period      = BASIC_TIMx_PERIOD;   // 
  HAL_TIM_Base_Init(&htim6);                    // ʼʱ

  /* жǷѡʱԴ,ֻTIM1/2/3/4/5/6/7/8/12/15ѡʱԴ */
  if(IS_TIMx_MULTISOURCE(htim6.Instance))
  {
    /* 趨ʱԴΪĬڲʱԴ */
    sClockSourceConfig.ClockSource = TIM_CLOCKSOURCE_INTERNAL;
    HAL_TIM_ConfigClockSource(&htim6, &sClockSourceConfig);
  }
  /* жǷΪʱģʽ,ֻTIM1/2/3/4/5/6/7/8/15Ϊģʽ
   * ӵʱ,TIM12ź,ûӵڲĶʱ
   * TIM13/14/16/17ûź,Ϊģʽ
   */
  if(IS_TIMx_MASTER(htim6.Instance))
  {
    /* /ģʽ,ʵϲûõ⹦ */
    sMasterConfig.MasterOutputTrigger  = TIM_TRGO_RESET; // ,Ĭϸλ
    sMasterConfig.MasterOutputTrigger2 = TIM_TRGO2_RESET;// ߼ƶʱеTRGO2
    sMasterConfig.MasterSlaveMode = TIM_MASTERSLAVEMODE_DISABLE;// /ģʽ
    HAL_TIMEx_MasterConfigSynchronization(&htim6, &sMasterConfig);
  }
	  /* жģʽʱ */
  HAL_TIM_Base_Start_IT(&htim6);
}

/**
  * : ģʽ¶ʱĻص
  * : htimʱ
  *   ֵ: 
  * ˵    : 
  */
void HAL_TIM_PeriodElapsedCallback(TIM_HandleTypeDef *htim)
{
  if(__HAL_TIM_GET_IT_SOURCE(&htim6,TIM_IT_UPDATE)!=RESET)
  {
    ulHighFrequencyTimerTicks++;
    __HAL_TIM_CLEAR_IT(&htim6, TIM_IT_UPDATE);
  }
}


