#ifndef __MOTOR_SERVO_H
#define __MOTOR_SERVO_H

#include "bsp_CAN.h"
#include "stm32h7xx_hal.h"
#include <stdio.h>

#define   status_choice_id         0X01    //ģʽѡ
#define   open_loop_id             0X02	   //
#define	  current_id               0X03    //
#define	  career_id                0X04    //ٶ
#define   pos_id                   0X05    //λ  
#define   career_pos_id            0X06    //ٶλ
#define	  current_career_id        0X07    //ٶ
#define	  current_pos_id           0X08    //λ
#define   current_career_pos_id    0X09    //ٶλ
#define   Motor_configure_id       0x0A    //ָ



typedef enum {
    open_loop = 0X01	, //ģʽ
	  current   = 0X02 , //ģʽ
	  career   = 0X03  , //ٶģʽ
    pos = 0X04  , //λģʽ  
    career_pos = 0X05 , //ٶλģʽ
	  current_career = 0X06  ,//ٶģʽ
	  current_pos = 0X07,//λģʽ
    current_career_pos = 0X08,//ٶλģʽ
}Motor_servo_mode;


typedef  struct{
int16_t real_current;
int16_t real_velocity;
int32_t real_position; 
}Motor_status;







void motor_init(int motor_id);//ʼ
void motor_control(int motor_id,int Motor_servo_mode);//ģʽѡ
int Motor_open_loop_control(int Motor_id , int pwm);//
int Motor_current_control(int Motor_id,unsigned int pwm,  int current);//
int motor_career_control(int Motor_id,unsigned int pwm, int career);//ٶȿ
int Motor_pos_control(int Motor_id ,unsigned int pwm , int pos);//λÿ
int Motor_career_pos(int Motor_id ,unsigned int pwm , int career, int pos);//ٶλÿ
int Motor_current_career(int Motor_id , int current, int career);//ٶȿ
int Motor_current_pos(int Motor_id , int current, int career);//λÿ
int Motor_current_career_pos(int Motor_id , int current, int career, int pos);//ٶλÿ
int Motor_current_career_pos_dispose(int Motor_id , int motor_retroaction, int level_retroaction );//Ƿʱ
void Motor_status_analysis(void);//Ϣ
void motor_speed_status(void);//ٶȽ
#endif 
