#ifndef   __SBUS_H
#define   __SBUS_H

#include "stm32h7xx_hal.h"
#include <stdio.h>
#include "balance.h"

void sbus_receive(void);

typedef struct
{
  unsigned long int one_channel;
  unsigned long int two_channel;
  unsigned long int three_channel;
	unsigned long int four_channel;
	unsigned long int five_channel;
	unsigned long int six_channel;
	unsigned long int seven_channel;
	unsigned long int eight_channel;
	unsigned long int night_channel;
	unsigned long int ten_channel;
}sbus_status;

#define manual_forward 1
#define manual_backward 2
#define manual_left 3
#define manual_right 4

void sbus_control(void);

#endif
