/* ͷļ ----------------------------------------------------------------*/
#include "stm32h7xx_hal.h"
#include "string.h"
#include  <stdarg.h>
#include "bsp_BasicTIM.h" 
#include "bsp_key.h"
#include "bsp_led.h"
#include "cmsis_os.h"
#include "bsp_usart1.h"
#include "bsp_usart2.h"
#include "bsp_usart3.h"
#include "bsp_usart6.h"
#include "bsp_uart4.h"
#include "bsp_uart5.h"
#include "bsp_uart7.h"
#include "bsp_RS485.h"
#include "bsp_CAN.h"
#include "fifo_buffer.h"
#include "sbus.h"
#include "imu.h"
#include "fashion_star_uart_servo.h"
#include "motor_servo.h"
#include "sensorcheck.h"
#include "autotask.h"
#include "manualtask.h"

/* ˽Ͷ --------------------------------------------------------------*/
uint8_t RxBuffer[7];


/* ˽к궨 ----------------------------------------------------------------*/

/* ˽б ------------------------------------------------------------------*/
static TaskHandle_t xHandleTaskautotask = NULL;
static TaskHandle_t xHandleTaskmanualtask = NULL;
static TaskHandle_t xHandleTasksensorchecktask = NULL;
static TaskHandle_t xHandleTaskimutask = NULL;
static SemaphoreHandle_t  xMutex = NULL;

KEY key1,key2,key3,key4,key5;

/* չ ------------------------------------------------------------------*/

/* ˽кԭ --------------------------------------------------------------*/
static void SystemClock_Config(void);
static void CPU_CACHE_Enable(void);
static void vTaskautotask(void *pvParameters);
static void vTaskmanualtask(void *pvParameters); 
static void vTasksensorchecktask(void *pvParameters); 
static void vTaskimutask(void *pvParameters); 
static void AppTaskCreate (void);
static void AppObjCreate (void);
void  App_Printf(char *format, ...);

/*  --------------------------------------------------------------------*/
/**
  * : .
  * : 
  *   ֵ: 
  * ˵    : 
  */
int main(void)
{
  

  CPU_CACHE_Enable();
  /* λ裬ʼFlashӿںϵͳδʱ(HSI) */
  HAL_Init();
  
	
	
  /* ϵͳʱ */
  SystemClock_Config();

  /* USARTڳʼ */
	USART1_Init();
	USART2_Init();
  USART3_Init();
	UART4_Init();
	UART5_Init();
	USART6_Init();
	UART7_Init();
	RS485_UART8_Init();
	
	
	  /* ʹܽж */
  __HAL_UART_ENABLE_IT(&husart1,UART_IT_RXNE);
	__HAL_UART_ENABLE_IT(&husart2,UART_IT_RXNE);   
	__HAL_UART_ENABLE_IT(&husart3,UART_IT_RXNE);
	__HAL_UART_ENABLE_IT(&huart4,UART_IT_RXNE);
	__HAL_UART_ENABLE_IT(&huart5,UART_IT_RXNE);
	__HAL_UART_ENABLE_IT(&husart6,UART_IT_RXNE);
	__HAL_UART_ENABLE_IT(&huart7,UART_IT_RXNE);
	
	
	 /* CANxʼ */
  MX_CAN1_Init();
	
  /* CANyʼ */
	
  MX_CAN2_Init();  
  
	
	
 

	motor_init(0x100);//λ 
	HAL_Delay(500);
  motor_control(0x100,0x03);//ģʽѡ
	HAL_Delay(500);
	Motor_current_career_pos_dispose(0x100,0x64,0X00);//Ϣʱ
	HAL_Delay(500);
	/* ں˿ǰرHALʱ׼ */
	HAL_SuspendTick();
	/* 
	  ǰΪ˷ֹʼSTM32ʱжϷִУֹȫж(NMIHardFault)
	  ĺôǣ
	  1. ִֹежϷFreeRTOSAPI
	  2. ֤ϵͳܱжӰ졣
	  3. ǷرȫжϣҸԼʵüɡ
	  ֲļport.cеĺprvStartFirstTaskл¿ȫжϡָͨcpsie i__set_PRIMASK(1)
	  cpsie iǵЧġ
     */
	__set_PRIMASK(1);  	
	

	
	/*  */
	AppTaskCreate();
  /* ͨŻ */
	AppObjCreate();
  /* ȣʼִ */
  vTaskStartScheduler();
  
  while (1)
  {

  }
}

/*
*********************************************************************************************************
*	  : vTaskautotask
*	˵: 
*	    : pvParameters ڴʱݵβ
*	  ֵ: 
*     : 1  (ֵԽСȼԽͣuCOS෴)
*********************************************************************************************************
*/
static void  vTaskautotask(void *pvParameters)
{   
	  TickType_t xLastWakeTime;
	  const TickType_t xFrequency = 300;
	  xLastWakeTime = xTaskGetTickCount();

    while(1)
    {
    /* ź */
		xSemaphoreTake(xMutex, portMAX_DELAY);			
 		autotask();
		xSemaphoreGive(xMutex);
		/* vTaskDelayUntilǾӳ٣vTaskDelayӳ١*/
    vTaskDelayUntil(&xLastWakeTime, xFrequency);
	  }
}

/*
*********************************************************************************************************
*	  : vTaskmanualtask
*	˵: 
*	    : pvParameters ڴʱݵβ
*	  ֵ: 
*     : 1  (ֵԽСȼԽͣuCOS෴)
*********************************************************************************************************
*/
static void  vTaskmanualtask(void *pvParameters)
{
	  TickType_t xLastWakeTime;
	  const TickType_t xFrequency = 300;
	  xLastWakeTime = xTaskGetTickCount();

    while(1)
    {
		 /* ź */
		 xSemaphoreTake(xMutex, portMAX_DELAY);	
		 manualtask();
		 xSemaphoreGive(xMutex);
		 /* vTaskDelayUntilǾӳ٣vTaskDelayӳ١*/
     vTaskDelayUntil(&xLastWakeTime, xFrequency);
	  }
}


/*
*********************************************************************************************************
*	  : vTasksensorchecktask
*	˵: 
*	    : pvParameters ڴʱݵβ
*	  ֵ: 
*     : 1  (ֵԽСȼԽͣuCOS෴)
*********************************************************************************************************
*/
static void  vTasksensorchecktask(void *pvParameters)
{


    while(1)
    {
 		 sensorcheck();
		 vTaskDelay(60);
	  }
}

/*
*********************************************************************************************************
*	  : vTasksensorchecktask
*	˵: 
*	    : pvParameters ڴʱݵβ
*	  ֵ: 
*     : 1  (ֵԽСȼԽͣuCOS෴)
*********************************************************************************************************
*/
static void  vTaskimutask(void *pvParameters)
{
	  
	  
	  

    while(1)
    {
 		 IMU_Status();//ݽ
		 vTaskDelay(60);
	  }
}

		
/**
  * : Ӧ
  * : 
  *   ֵ: 
  * ˵    : 
  */
static void AppTaskCreate (void)
{

xTaskCreate( vTaskautotask,   	/*   */
                 "vTaskautotask",     	/*     */
                 512,               	/* ջСλwordҲ4ֽ */
                 NULL,              	/*   */
                 1,                 	/* ȼ*/
                 &xHandleTaskautotask );  /*   */ 
	
	 xTaskCreate( vTaskmanualtask,   	/*   */
                 "vTaskmanualtask",     	/*     */
                 512,               	/* ջСλwordҲ4ֽ */
                 NULL,              	/*   */
                 1,                 	/* ȼ*/
                 &xHandleTaskmanualtask );  /*   */ 
	 xTaskCreate( vTasksensorchecktask,   	/*   */
                 "vTasksensorchecktask",     	/*     */
                 512,               	/* ջСλwordҲ4ֽ */
                 NULL,              	/*   */
                 1,                 	/* ȼ*/
                 &xHandleTasksensorchecktask );  /*   */ 
	xTaskCreate( vTaskimutask,   	/*   */
                 "vTaskimutask",     	/*     */
                 512,               	/* ջСλwordҲ4ֽ */
                 NULL,              	/*   */
                 1,                 	/* ȼ*/
                 &xHandleTaskimutask );  /*   */
}

/**
  * : ͨŻ
  * : 
  *   ֵ: 
  * ˵    : 
  */
static void AppObjCreate (void)
{
	/* ź */
    xMutex = xSemaphoreCreateMutex();
	
	 if(xMutex == NULL)
    {
        /* ûдɹû봴ʧܵĴ */
    }
}

/**
  * : ̰߳ȫprintfʽ
  * : 
  *   ֵ: 
  * ˵    : 
  */
void  App_Printf(char *format, ...)
{
    char  buf_str[200 + 1];
    va_list   v_args;


    va_start(v_args, format);
   (void)vsnprintf((char       *)&buf_str[0],
                   (size_t      ) sizeof(buf_str),
                   (char const *) format,
                                  v_args);
    va_end(v_args);

	/* ź */
	xSemaphoreTake(xMutex, portMAX_DELAY);

    printf("%s", buf_str);

   	xSemaphoreGive(xMutex);
}

/**
  * : ϵͳʱ
  * : 
  *   ֵ: 
  * ˵    : 
  */
static void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct={0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct={0};
  RCC_PeriphCLKInitTypeDef PeriphClkInitStruct={0};

  /* ʹPWRø */
  MODIFY_REG(PWR->CR3, PWR_CR3_SCUEN, 0);

  /* õѹѹ1 */
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);

  /* ȴD3VOS ׼ */
  while ((PWR->D3CR & (PWR_D3CR_VOSRDY)) != PWR_D3CR_VOSRDY) // ȴں˵Դ
  {
    
  }
  __HAL_RCC_PLL_PLLSOURCE_CONFIG(RCC_PLLSOURCE_HSE);
  
  /* RCC ڲ/ⲿ ,CPUAHBAPHʱ */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;// ⲿ
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;//ѡⲿʱӾ HSE 25MHz
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;//ʹPLL
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;//PLLʱԴѡHSE
  RCC_OscInitStruct.PLL.PLLM = 5;  // ⲿʱ2Ƶ,õ5MHz ΪPLLʱԴ
  RCC_OscInitStruct.PLL.PLLN = 160; // PLL 160Ƶ,õ800MHz PLLCLK
  RCC_OscInitStruct.PLL.PLLP = 2;  // PLLCLK 2Ƶ õ400MHz SYSCLK
  RCC_OscInitStruct.PLL.PLLQ = 20;  // PLLCLK 2Ƶ õ40MHzڲʱ
  RCC_OscInitStruct.PLL.PLLR = 2;  // PLLCLK 2Ƶ õ400MHzڲʱ
  RCC_OscInitStruct.PLL.PLLRGE = RCC_PLL1VCIRANGE_2;// PLLʱ뷶Χ4-8MHz
  RCC_OscInitStruct.PLL.PLLVCOSEL = RCC_PLL1VCOWIDE;// PLLʱΧ192-836MHz
  RCC_OscInitStruct.PLL.PLLFRACN = 0;  // ˲΢ PLL1 VCO Χ0~2^13-1
  HAL_RCC_OscConfig(&RCC_OscInitStruct);
  
  /* RCC CPUAHBAPHʱ*/
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2
                              |RCC_CLOCKTYPE_D3PCLK1|RCC_CLOCKTYPE_D1PCLK1;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;//SYSCLK ʱԴ400MHz
  RCC_ClkInitStruct.SYSCLKDivider  = RCC_SYSCLK_DIV1;// SYSCLK 1Ƶ HCLK=400MHz
  RCC_ClkInitStruct.AHBCLKDivider  = RCC_HCLK_DIV2;  // HCLK 2ƵAHB = 200Mhz
  RCC_ClkInitStruct.APB3CLKDivider = RCC_APB3_DIV2; // APB3 2ƵAPB3 = 100MHz
  RCC_ClkInitStruct.APB1CLKDivider = RCC_APB1_DIV2; // APB1 2ƵAPB1 = 100MHz
  RCC_ClkInitStruct.APB2CLKDivider = RCC_APB2_DIV2; // APB2 2ƵAPB2 = 100MHz
  RCC_ClkInitStruct.APB4CLKDivider = RCC_APB4_DIV2; // APB4 2ƵAPB4 = 100MHz
  HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2);
  
  PeriphClkInitStruct.PeriphClockSelection = RCC_PERIPHCLK_USART1|RCC_PERIPHCLK_USART2|RCC_PERIPHCLK_UART4|RCC_PERIPHCLK_UART5|RCC_PERIPHCLK_USART6|RCC_PERIPHCLK_UART7|RCC_PERIPHCLK_UART8|RCC_PERIPHCLK_FDCAN;
	PeriphClkInitStruct.FdcanClockSelection = RCC_FDCANCLKSOURCE_PLL;
  PeriphClkInitStruct.Usart234578ClockSelection = RCC_USART234578CLKSOURCE_D2PCLK1;
  PeriphClkInitStruct.Usart16ClockSelection = RCC_USART16CLKSOURCE_D2PCLK2;
  HAL_RCCEx_PeriphCLKConfig(&PeriphClkInitStruct);
  
  /* ʹʱӰȫ */
  HAL_RCC_EnableCSS();

  /* δʱ1ms */
  // SystemCoreClock/1000    1msжһ
	// SystemCoreClock/100000	 10usжһ
	// SystemCoreClock/1000000 1usжһ
  HAL_SYSTICK_Config(SystemCoreClock/(1000));

  /* ϵͳδʱʱԴ */
  HAL_SYSTICK_CLKSourceConfig(SYSTICK_CLKSOURCE_HCLK);

  /* ϵͳδʱжȼ */
  HAL_NVIC_SetPriority(SysTick_IRQn, 0, 0);
}

/**
  * : ʹCPU L1-Cache
  * : 
  *   ֵ: 
  * ˵    : 
  */
static void CPU_CACHE_Enable(void)
{
  /* ʹ I-Cache */
  SCB_EnableICache();

  /* ʹ D-Cache */
  SCB_EnableDCache();
}


